//
//  ContentView.swift
//  ScrollBug
//
//  Created by Marc Palmer on 11/10/2021.
//

import SwiftUI

struct ContentView: View {
    let items: [Int] = Array(0...50)
    var body: some View {
        VStack {
            Text("Keep tapping items to scroll them to center and it will drift to the side sometimes")

            GeometryReader { geometryProxy in
                ScrollViewReader { scrollProxy in
                    ScrollView(.vertical) {
                        VStack(spacing: 20) {
                            ForEach(items, id: \.self) { item in
                                Text("Item #\(item)")
                                .id(item)
                                .frame(height: 100)
                                .frame(width: 200)
                                .background(Color.green)
                                .onTapGesture {
                                    withAnimation {
                                        scrollProxy.scrollTo(item, anchor: .center)
                                    }
                                }
                                .contentShape(Rectangle())
                            }
                        }
                        .padding(.horizontal, 20) /// <<< This padding causes the bug
                        .frame(width: geometryProxy.size.width)
                    }
                }
            }
        }
        .frame(maxWidth: .infinity, maxHeight: .infinity)
    }
}

struct ContentView_Previews: PreviewProvider {
    static var previews: some View {
        ContentView()
    }
}
